function [res1] = CalculateTransitionBetweenFramesTLS(u, v, dx, dy, itQty, interpType, useTLS, step, gradientType) 

if (strcmp(gradientType,'BD'))
    filterMatrix = true(size(u));
    filterMatrix(1:end,size(filterMatrix,2):end) = false;
    filterMatrix(size(filterMatrix,1):end,1:end) = false;
    u(1:end-1,1:end-1) = (u(1:end-1,1:end-1) + u(1:end-1, 2:end) + u(2:end, 1:end-1) + u(2:end,2:end)) / 4;
    
elseif (strcmp(gradientType,'CENTER3'))
    filterMatrix = true(size(u));
    filterMatrix(1:end,end-2:end) = false;
    filterMatrix(end-2:end,1:end) = false;
    filterMatrix(1:end,1:3) = false;
    filterMatrix(1:3,1:end) = false;
elseif (strcmp(gradientType,'CENTER2'))
    filterMatrix = true(size(u));
    filterMatrix(1:end,end-1:end) = false;
    filterMatrix(end-1:end,1:end) = false;
    filterMatrix(1:end,1:2) = false;
    filterMatrix(1:2,1:end) = false;
elseif (strcmp(gradientType,'CENTER1'))
    filterMatrix = true(size(u));
    filterMatrix(1:end,end) = false;
    filterMatrix(end,1:end) = false;
    filterMatrix(1:end,1) = false;
    filterMatrix(1,1:end) = false;
    
end
filterMatrix(isnan(dx)) = false;
filterMatrix(isnan(dy)) = false;
vAligned = v;
res1 = [0;0];
for i = 1:itQty
    if (strcmp(gradientType,'BD'))
        vAligned(1:end-1,1:end-1) = (vAligned(1:end-1,1:end-1) + vAligned(1:end-1, 2:end) + vAligned(2:end, 1:end-1) + vAligned(2:end,2:end)) / 4;
    end
    filterMatrix(isnan(vAligned)) = false;
    dif = vAligned - u;
    dx2 = dx(filterMatrix);
    dy2 = dy(filterMatrix);
    dif = dif(filterMatrix);
    A = [dx2(:) dy2(:)];
    A = A(1:step:end,:);
    dif = dif(:);
    dif = dif(1:step:end);
    if (~useTLS)
        % Linear Least Squares Minimization
        res1 = res1 + (A'*A)\(A'*dif);
    else
        % Total Least Squares Minimization
        Z = [A dif];              % Z is X augmented with Y.
        [~, S, ~] = svd(Z,0);           % find the SVD of Z.
        AtA = A'*A;
        if (size(S,1) >= 3 && size(S,2) >= 3)
            res1 = res1 + (AtA - S(3,3)*S(3,3)*eye(size(AtA)))\(A'*dif);
        else
            res1 = res1 + [0;0];
        end
    end
    if (abs(res1(1)) > 5 || abs(res1(2)) > 5)
        res1 = [0;0];
    end
    if (i < itQty)
        Xi = repmat(1:size(vAligned,2), size(v,1),1) - res1(1);
        Yi = repmat((1:size(vAligned,1))', 1,size(v,2)) - res1(2);
        % This is because of a Matlab BUG for spline interpolation.
        try
            if (strcmp(interpType,'spline') == true && res1(1) > 0 && res1(2) > 0 && isnan(v(1,end)) && isnan(v(end,1)))
                v2 = v(1:end-1,:);
                v2 = v2(:, 1:end-1);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(end-1:end,1:end) = nan;
                vAligned(1:end,end-1:end) = nan;
            elseif (strcmp(interpType,'spline') == true && res1(1) < 0 && res1(2) < 0 && isnan(v(end,1)) && isnan(v(1,end)))
                v2 = v(2:end,:);
                v2 = v2(:, 2:end);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(1:2,:) = nan;
                vAligned(:,1:2) = nan;
            elseif (strcmp(interpType,'spline') == true && res1(1) > 0 && res1(2) < 0 && isnan(v(1,1)) && isnan(v(end,end)))
                v2 = v(2:end,:);
                v2 = v2(:, 1:end-1);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(1:2,:) = nan;
                vAligned(:,end-1:end) = nan;
            elseif (strcmp(interpType,'spline') == true && res1(1) < 0 && res1(2) > 0 && isnan(v(1,1)) && isnan(v(end,end)))
                v2 = v(1:end-1,:);
                v2 = v2(:, 2:end);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(end-1:end,:) = nan;
                vAligned(:,1:2) = nan;
            else
                try 
                    vAligned = interp2(1:size(v,2), 1:size(v,1), v, Xi, Yi, interpType);
                catch
                    res1 = [0;0];
                    break;
                end
            end
        catch 
            res1 = [0;0];
            break;
        end
        
    end
end