function [output] = CalculateUnbiasedTransition(u, v, dx, dy, variance, itQty, interpType, step)


filterMatrix = true(size(u));
filterMatrix(1:end,size(filterMatrix,2):end) = false;
filterMatrix(size(filterMatrix,1):end,1:end) = false;
filterMatrix(isnan(dx)) = false;
filterMatrix(isnan(dy)) = false;
u(1:end-1,1:end-1) = (u(1:end-1,1:end-1) + u(1:end-1, 2:end) + u(2:end, 1:end-1) + u(2:end,2:end)) / 4;
vAligned = v;
output = [0;0];

for i = 1:itQty
    vAligned(1:end-1,1:end-1) = (vAligned(1:end-1,1:end-1) + vAligned(1:end-1, 2:end) + vAligned(2:end, 1:end-1) + vAligned(2:end,2:end)) / 4;
    filterMatrix(isnan(vAligned)) = false;
    dif = vAligned - u;
    dx2 = dx(filterMatrix);
    dy2 = dy(filterMatrix);
    dif = dif(filterMatrix);
    A = [dx2(:) dy2(:)];
    A = A(1:step:end,:);
    dif = dif(:);
    dif = dif(1:step:end);
    N = size(dx2,1);
    % Only do the bias compensation on the first iteration (since the
    % variance of the noise changes in the second image)
    if (i == 1)
        output = output + (A'*A - (variance * N) * eye(2))\(A'*dif);
    else
        output = output + (A'*A)\(A'*dif);
    end
    if (abs(output(1)) > 5 || abs(output(2)) > 5)
        output = [0;0];
    end

    %v(1:end-1,1:end-1) = (v(1:end-1,1:end-1) + v(1:end-1, 2:end) + v(2:end, 1:end-1) + v(2:end,2:end)) / 4;
    %filterMatrix(isnan(v)) = false;
    %dif = v - u;
    %dx = dx(filterMatrix);
    %dy = dy(filterMatrix);
    %dif = dif(filterMatrix);
    %dx = dx(:);
    %dy = dy(:);
    %dif = dif(:);
    %N = size(dx,1);
    %sIx2 = sum(dx.^2) - 2 * variance * N;
    %sIy2 = sum(dy.^2) - 2 * variance * N;
    %sIxIt = sum(dx.* dif) - variance * N;
    %sIyIt = sum(dy.* dif) - variance * N;
    %sIxIy = sum(dx.*dy) - variance * N;
    %Det = sIx2 * sIy2 - sIxIy;
    %output = zeros(2,1);
    %output(1) = (sIxIt*sIy2 - sIyIt * sIxIy) / Det;
    %output(2) = (sIyIt*sIx2 - sIxIt * sIxIy) / Det;

    %A = [dx dy];
    %output = (A'*A)\(A'*dif);
    if (i < itQty)
        Xi = repmat(1:size(vAligned,2), size(v,1),1) - output(1);
        Yi = repmat((1:size(vAligned,1))', 1,size(v,2)) - output(2);
        % This is because of a Matlab BUG for spline interpolation.
        try
            if (strcmp(interpType,'spline') == true && output(1) > 0 && output(2) > 0 && isnan(v(1,end)) && isnan(v(end,1)))
                v2 = v(1:end-1,:);
                v2 = v2(:, 1:end-1);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(end-1:end,1:end) = nan;
                vAligned(1:end,end-1:end) = nan;
            elseif (strcmp(interpType,'spline') == true && output(1) < 0 && output(2) < 0 && isnan(v(end,1)) && isnan(v(1,end)))
                v2 = v(2:end,:);
                v2 = v2(:, 2:end);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(1:2,:) = nan;
                vAligned(:,1:2) = nan;
            elseif (strcmp(interpType,'spline') == true && output(1) > 0 && output(2) < 0 && isnan(v(1,1)) && isnan(v(end,end)))
                v2 = v(2:end,:);
                v2 = v2(:, 1:end-1);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(1:2,:) = nan;
                vAligned(:,end-1:end) = nan;
            elseif (strcmp(interpType,'spline') == true && output(1) < 0 && output(2) > 0 && isnan(v(1,1)) && isnan(v(end,end)))
                v2 = v(1:end-1,:);
                v2 = v2(:, 2:end);
                vAligned = interp2(1:size(v2,2), 1:size(v2,1), v2, Xi, Yi, interpType);
                vAligned(end-1:end,:) = nan;
                vAligned(:,1:2) = nan;
            else
                try 
                    vAligned = interp2(1:size(v,2), 1:size(v,1), v, Xi, Yi, interpType);
                catch
                    output = [0;0];
                    break;
                end
            end
        catch 
            output = [0;0];
            break;
        end
        
    end
end
