function [qtyMethods, methods, RMSE] = EvaluateAlgorithms(u, v, uClean, vClean, shift, sigma2, a)
    qtyMethods = 79;
    methods = cell(0);
    methods{end+1} = 'LS1';
    methods{end+1} = 'LS2L';
    methods{end+1} = 'LS2C';
    methods{end+1} = 'LS3L';
    methods{end+1} = 'LS3C';
    methods{end+1} = 'LS3S';
    methods{end+1} = 'LS4S';
    methods{end+1} = 'TLS1';
    methods{end+1} = 'TLS2L';
    methods{end+1} = 'TLS2C';
    methods{end+1} = 'TLS3L';
    methods{end+1} = 'TLS3C';
    methods{end+1} = 'TLS3S';
    methods{end+1} = 'TLS4S';
    methods{end+1} = 'LS1OG';
    methods{end+1} = 'LS2LOG';
    methods{end+1} = 'LS2COG';
    methods{end+1} = 'LS3LOG';
    methods{end+1} = 'LS3COG';
    methods{end+1} = 'LS3SOG';
    methods{end+1} = 'LS4SOG';
    methods{end+1} = 'LS1OI';
    methods{end+1} = 'LS2LOI';
    methods{end+1} = 'LS2COI';
    methods{end+1} = 'LS3LOI';
    methods{end+1} = 'LS3COI';
    methods{end+1} = 'LS3SOI';
    methods{end+1} = 'LS4SOI';
    methods{end+1} = 'CLS1';
    methods{end+1} = 'CLS2L';
    methods{end+1} = 'CLS2C';
    methods{end+1} = 'CLS3L';
    methods{end+1} = 'CLS3C';
    methods{end+1} = 'CLS3S';
    methods{end+1} = 'CLS1OS';
    methods{end+1} = 'CLS2LOS';
    methods{end+1} = 'CLS2COS';
    methods{end+1} = 'CLS3LOS';
    methods{end+1} = 'CLS3COS';
    methods{end+1} = 'CLS3SOS';
    methods{end+1} = 'LS1G3';
    methods{end+1} = 'LS2LG3';
    methods{end+1} = 'LS2CG3';
    methods{end+1} = 'LS3LG3';
    methods{end+1} = 'LS3CG3';
    methods{end+1} = 'LS3SG3';
    methods{end+1} = 'LS4SG3';
    methods{end+1} = 'LS1G4';
    methods{end+1} = 'LS2LG4';
    methods{end+1} = 'LS2CG4';
    methods{end+1} = 'LS3LG4';
    methods{end+1} = 'LS3CG4';
    methods{end+1} = 'LS3SG4';
    methods{end+1} = 'LS4SG4';
    methods{end+1} = 'LS1G5';
    methods{end+1} = 'LS2LG5';
    methods{end+1} = 'LS2CG5';
    methods{end+1} = 'LS3LG5';
    methods{end+1} = 'LS3CG5';
    methods{end+1} = 'LS3SG5';
    methods{end+1} = 'LS4SG5';
    methods{end+1} = 'ULSG1';
    methods{end+1} = 'ULSG2';
    methods{end+1} = 'ULSG3';
    methods{end+1} = 'ULSG4';
    methods{end+1} = 'ULSG5';
    methods{end+1} = 'ULS2G1';
    methods{end+1} = 'ULS2G2';
    methods{end+1} = 'ULS2G3';
    methods{end+1} = 'ULS2G4';
    methods{end+1} = 'ULS2G5';
    methods{end+1} = 'ULS3G1';
    methods{end+1} = 'ULS3G2';
    methods{end+1} = 'ULS3G3';
    methods{end+1} = 'ULS3G4';
    methods{end+1} = 'ULS3G5';
    methods{end+1} = 'ULS4G1';
    methods{end+1} = 'ULS4G3';
    methods{end+1} = 'ULS4G5';
    if (isempty(u))
        RMSE = [];
        return;
    end
    RMSE = zeros(0,1);
    step = 1;
    [dxFDVST, dyFDVST] = CalculateGradient(u);
    [dxFDNoNoise, dyFDNoNoise] = CalculateGradient(uClean);
    [dxFDVST2, dyFDVST2] = CalculateGradient2(u);
    [dxFDVST3, dyFDVST3] = CalculateGradient3(u,1);
    [dxFDVST4, dyFDVST4] = CalculateGradient3(u,0.6);
    [dxFDVST5, dyFDVST5] = CalculateGradient3(u,0.3);

    
    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 1, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 2, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 2, 'bicubic', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 3, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 3, 'bicubic', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 3, 'spline', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 4, 'spline', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 1, 'bilinear', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 2, 'bilinear', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 2, 'bicubic', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 3, 'bilinear', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 3, 'bicubic', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 3, 'spline', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST, dyFDVST, 4, 'spline', true, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 1, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 2, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 2, 'bicubic', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 3, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 3, 'bicubic', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 3, 'spline', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDNoNoise, dyFDNoNoise, 4, 'spline', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 1, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 2, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 2, 'bicubic', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 3, 'bilinear', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 3, 'bicubic', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 3, 'spline', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(uClean, vClean, dxFDNoNoise, dyFDNoNoise, 4, 'spline', false, step, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, sigma2, 1, 'bilinear', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, sigma2, 2, 'bilinear', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, sigma2, 2, 'bicubic', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, sigma2, 3, 'bilinear', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, sigma2, 3, 'bicubic', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, sigma2, 3, 'spline', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, a^2, 1, 'bilinear', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, a^2, 2, 'bilinear', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, a^2, 2, 'bicubic', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, a^2, 3, 'bilinear', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, a^2, 3, 'bicubic', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransition(u, v, dxFDVST, dyFDVST, a^2, 3, 'spline', 1);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 1, 'bilinear', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 2, 'bilinear', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 2, 'bicubic', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 3, 'bilinear', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 3, 'bicubic', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 3, 'spline', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST3, dyFDVST3, 4, 'spline', false, step, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);
    
    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 1, 'bilinear', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 2, 'bilinear', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 2, 'bicubic', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 3, 'bilinear', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 3, 'bicubic', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 3, 'spline', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST4, dyFDVST4, 4, 'spline', false, step, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 1, 'bilinear', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 2, 'bilinear', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 2, 'bicubic', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 3, 'bilinear', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 3, 'bicubic', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 3, 'spline', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateTransitionBetweenFramesTLS(u, v, dxFDVST5, dyFDVST5, 4, 'spline', false, step, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFrames(u, v, dxFDVST, dyFDVST, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFrames(u, v, dxFDVST2, dyFDVST2, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFrames(u, v, dxFDVST3, dyFDVST3, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFrames(u, v, dxFDVST4, dyFDVST4, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFrames(u, v, dxFDVST5, dyFDVST5, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCenterBySmallestNorm(u, v, dxFDVST, dyFDVST, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCenterBySmallestNorm(u, v, dxFDVST2, dyFDVST2, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCenterBySmallestNorm(u, v, dxFDVST3, dyFDVST3, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCenterBySmallestNorm(u, v, dxFDVST4, dyFDVST4, 'CENTER2');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCenterBySmallestNorm(u, v, dxFDVST5, dyFDVST5, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCLS(u, v, dxFDVST, dyFDVST, 'BD',a^2);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCLS(u, v, dxFDVST2, dyFDVST2, 'BD',a^2);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCLS(u, v, dxFDVST3, dyFDVST3, 'CENTER3',a^2);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCLS(u, v, dxFDVST4, dyFDVST4, 'CENTER2',a^2);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateUnbiasedTransitionBetweenFramesCLS(u, v, dxFDVST5, dyFDVST5, 'CENTER1',a^2);
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateSmartUnbiasedTransitionBetweenFrames(u, v, dxFDVST, dyFDVST, 'BD');
    RMSE(end+1) = EvaluateError(shift, res);
    
    [res] = CalculateSmartUnbiasedTransitionBetweenFrames(u, v, dxFDVST3, dyFDVST3, 'CENTER3');
    RMSE(end+1) = EvaluateError(shift, res);

    [res] = CalculateSmartUnbiasedTransitionBetweenFrames(u, v, dxFDVST5, dyFDVST5, 'CENTER1');
    RMSE(end+1) = EvaluateError(shift, res);
    
    

end