function [res] = FourierShift(deltaX, deltaY, img)
    F = fft2(img);
    res = F;
    [h,w] = size(F(:,:,1));
    if (mod(w,2) == 0)
        limHoriz = w/2;
    else
        limHoriz = (w-1)/2;
    end
    if (mod(h,2) == 0)
        limVert = h/2;
    else
        limVert = (h-1)/2;
    end
    for i=1:size(F,3)
        for x=-limHoriz:limHoriz
            for y=-limVert:limVert
                if (x < 1) 
                    posX = w + x;
                else
                    posX = x;
                end
                if (y < 1)
                    posY = h + y;
                else
                    posY = y;
                end
                res(posY,posX,i) = res(posY,posX,i).*exp(-2*pi*1i*(((x-1)*(deltaX)/w)+((y-1)*(deltaY)/h)));
                %res(posY,posX,i) = res(posY,posX,i).*exp(-2*pi*1i*(((x)*(deltaX)/w)+((y)*(deltaY)/h)));
            end
        end
    end
    res = abs(ifft2(res));
    %res = uint8(res);
end